'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = connectSource;

var _reselect = require('reselect');

var _reactRedux = require('react-redux');

var _utils = require('redux-source/lib/utils');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function connectSource(_ref, _ref2) {
  var stateName = _ref.stateName,
      denormalize = _ref.denormalize,
      actions = _ref.actions;
  var slice = _ref2.slice,
      actionsProp = _ref2.actionsProp;

  var mapStateToProps = function mapStateToProps(oldState) {
    for (var _len = arguments.length, other = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      other[_key - 1] = arguments[_key];
    }

    var newState = (0, _utils.unwrap)(oldState);
    return (0, _reselect.createSelector)([function (state) {
      return slice(state).getIn([stateName, 'result']);
    }, function (state) {
      return slice(state).getIn([stateName, 'entities']);
    }, function (state) {
      return slice(state).getIn([stateName, 'errors']);
    }, function (state) {
      return slice(state).getIn([stateName, 'isPending']);
    }], function (result, entities, errors, isPending) {
      var res = denormalize(result.toJS(), entities.toJS());
      // console.log(
      //   'denormalize',
      //   { result: result.toJS(), entities: entities.toJS() },
      //   res,
      // );
      var errorList = errors.toJS();
      if ((typeof console === 'undefined' ? 'undefined' : _typeof(console)) === 'object' && console.error) {
        errorList.forEach(function (error) {
          return console.error(error.stack);
        });
      }
      return _defineProperty({}, stateName, {
        result: res,
        errors: errorList,
        isPending: isPending
      });
    }).apply(undefined, [newState].concat(other));
  };
  var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return actionsProp ? _defineProperty({}, actionsProp, (0, _utils.bindActionCreators)(actions, dispatch)) : {};
  };
  return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps);
}
module.exports = exports['default'];
//# sourceMappingURL=connectSource.js.map